#!/bin/sh

# Exercise copying of ACLs
echo "ACL handling"
# Basic test configuration
TESTDIR=/mnt/da0/acl-test
. `dirname $0`/config.sh

# Create some files with ACLs
mkdir original
cd original
touch a
chmod 664 a
setfacl -m user:bin:rw- -m group:78:r-x a \
    || echo XXX failed to set access ACL on a XXX
mkdir d
chmod 775 d
setfacl -m user:daemon:rw- -m group:78:r-x d \
    || echo XXX failed to set access ACL on d XXX
setfacl -d   -m user::rw- -m group::rw- -m other::rw- -m group:79:r-- d \
    || echo XXX failed to set default ACL on d XXX
cd ..

# Copy the dir with -p
echo "  -p preserves ACLs"
mkdir copy
(cd original && ${BSDTAR} -cf - .) | (cd copy; ${BSDTAR} -xpf -)

# Verify the ACLs
cd copy
if [ "user::rw- user:bin:rw- group::rw- group:78:r-x mask::rwx other::r--" \
    = "`echo \`getfacl -q a\``" ]; then
    # It matches!!
else
    echo XXX a has wrong ACL XXX `getfacl -q a`
fi

if [ "user::rwx user:daemon:rw- group::rwx group:78:r-x mask::rwx other::r-x" \
    = "`echo \`getfacl -q d\``" ]; then
    # It matches!!
else
    echo XXX d has wrong ACL XXX `getfacl -q d`
fi


if [ "user::rw- group::rw- group:79:r-- mask::rw- other::rw-" \
    = "`echo \`getfacl -q -d d\``" ]; then
    # It matches!!
else
    echo XXX d has wrong ACL XXX `getfacl -q -d d`
fi

